<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Document</title>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>

<body onload="onPageLoading()">
    <div class="container jumbotron">
        <h1 class="text-center">Danh sách người dùng đăng ký</h1>
        <table id="user-table" class="table table-bordered table-striped table-hover">
            <thead>
                <tr>
                    <th>Mã người dùng</th>
                    <th>Firstname</th>
                    <th>Lastname</th>
                    <th>Country</th>
                    <th>Subject</th>
                    <th>Customer Type</th>
                    <th>Register Status</th>
                    <th>Action</th>
                </tr>
            </thead>
            <tbody>

            </tbody>
        </table>
    </div>
    <script>
        "use strict";
        /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
        const gREQUEST_STATUS_OK = 200;
        const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
        const gBASE_URL = "http://203.171.20.210:8080/devcamp-register-java-api/users"
        const gEND_ROW_COL_TABLE = -1;
        /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */


        /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
        // hàm xử lý sự kiện loading
        function onPageLoading() {
            //B1
            //B2
            //B3
            var vXHTMLRequest = new XMLHttpRequest();
            goiApiLayThongTinUser(vXHTMLRequest);
            vXHTMLRequest.onreadystatechange = function () {
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                      //đây là responses text bạn có thể  phân tích
                    /*thêm code xử lý response*/
                    xuLyHienThiLenTable(vXHTMLRequest);
                }
            };
        }
        /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
        function goiApiLayThongTinUser(paramXmlHttp) {
            paramXmlHttp.open("GET", gBASE_URL, true);
            paramXmlHttp.send();
        }
        function xuLyHienThiLenTable(paramXmlHttp){
            console.log("responseText = " + paramXmlHttp.responseText);
            var vResponObj = JSON.parse(paramXmlHttp.responseText);
            var vUserTable = document.getElementById("user-table");
            var vTbodyTable = document.getElementsByTagName("tbody")[0];
            for(var bI = 0;bI < vResponObj.length;bI++){
                var bNewRow = vTbodyTable.insertRow(gEND_ROW_COL_TABLE);
                var bCellMaNguoiDung = bNewRow.insertCell(gEND_ROW_COL_TABLE);
                var bCellFirstName = bNewRow.insertCell(gEND_ROW_COL_TABLE);
                var bCellLastname = bNewRow.insertCell(gEND_ROW_COL_TABLE);
                var bCellCountry = bNewRow.insertCell(gEND_ROW_COL_TABLE);
                var bCellSubject = bNewRow.insertCell(gEND_ROW_COL_TABLE);
                var bCellCustomerType = bNewRow.insertCell(gEND_ROW_COL_TABLE);
                var bCellRegisterStatus = bNewRow.insertCell(gEND_ROW_COL_TABLE);
                var bCellAction = bNewRow.insertCell(gEND_ROW_COL_TABLE);
                bCellMaNguoiDung.innerHTML = vResponObj[bI].id;
                bCellFirstName.innerHTML = vResponObj[bI].firstname;
                bCellLastname.innerHTML = vResponObj[bI].lastname;
                bCellCountry.innerHTML = vResponObj[bI].country;
                bCellSubject.innerHTML = vResponObj[bI].subject;
                bCellCustomerType.innerHTML = vResponObj[bI].customerType;
                bCellRegisterStatus.innerHTML = vResponObj[bI].registerStatus;
                var bDetailButton = document.createElement("button");
                bDetailButton.className = "info-user btn btn-info";
                bDetailButton.innerHTML = "Chi tiết";
                bDetailButton.setAttribute("data-id",vResponObj[bI].id);
                bDetailButton.setAttribute("data-firstname",vResponObj[bI].firstname);
                bDetailButton.setAttribute("data-lastname",vResponObj[bI].lastname);
                bDetailButton.setAttribute("data-country",vResponObj[bI].country);
                bDetailButton.setAttribute("data-subject",vResponObj[bI].subject);
                bDetailButton.setAttribute("data-customer-type",vResponObj[bI].customerType);
                bDetailButton.setAttribute("data-register-status",vResponObj[bI].registerStatus);
                bDetailButton.setAttribute("onclick","onBtnDetailClick(this)");
                bCellAction.appendChild(bDetailButton);
            }

        }
        function onBtnDetailClick(paramButton){
            console.log("Nút chi tiết được ấn");
            var vUserId = paramButton.dataset.id;
            var vUserFirstname = paramButton.dataset.firstname;
            var vUserLastname = paramButton.dataset.lastname;
            var vUserCountry = paramButton.dataset.country;
            var vUserSubject = paramButton.dataset.subject;
            var vUserCustomerType = paramButton.dataset.customerType;
            var vUserRegisterStatus = paramButton.dataset.registerStatus;
            console.log("User ID: " + vUserId);
            console.log("User Firstname: " + vUserFirstname);
            console.log("User Lastname: " + vUserLastname);
            console.log("User Country: " + vUserCountry);
            console.log("User Subject: " + vUserSubject);
            console.log("User Customer Type: " + vUserCustomerType);
            console.log("User Register Status: " + vUserRegisterStatus);
            const vDETAIL_FROM_URL = "task 29.80.html";
            var vUrlSideOpen = vDETAIL_FROM_URL + "?" + "id=" + vUserId;
            window.location.href = vUrlSideOpen;
        }
    </script>
</body>

</html>